/*
* Try to delete a task, which is the mutex holder.
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

#include "tools.h"

xQueueHandle xMutex;

static void MutexHolder(void *);
static void Viewer(void *);

void delMutexH() {
    xMutex = xQueueCreateMutex(queueQUEUE_TYPE_MUTEX);

    xTaskCreate(MutexHolder, (signed char *) "Task1", 1000, NULL, 2, NULL);
    xTaskCreate(Viewer, (signed char *) "Task2", 1000, NULL, 1, NULL);

    vTaskStartScheduler();
}

void MutexHolder(void * xPara){
    long i;
    sPrint ("Task1 is running\n");

    if (xQueueTakeMutexRecursive(xMutex, 0)){
        for ( ;; ){
            sPrint ("Task1 holding xMutex!\n");
            for ( i = 0; i <= 100000; i++ );
            vTaskDelete(NULL);
        }
    } else {
        sPrint ("Task1 failed to take mutex!\n");
    }
}

void Viewer(void * xPara){
    for ( ;; ){
        sPrint ("Task2 is running\n");
        vTaskDelay(100);
    }
}