/*
* Try to delete a Mutex from the task, which did not
* hold it.
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

#include "tools.h"

xQueueHandle xMutex;
xTaskHandle xTaskD;

static void MutexHolder(void *);
static void Deleter(void *);

void delMutexO(void){
    xMutex = xQueueCreateMutex(queueQUEUE_TYPE_MUTEX);

    xTaskCreate(MutexHolder, (signed char *) "Task1", 1000, NULL, 1, NULL);
    xTaskCreate(Deleter, (signed char *) "Task2", 1000, NULL, 2, & xTaskD);

    vTaskStartScheduler();
}

void MutexHolder(void * xPara){
    BOOL tag = TRUE;
    sPrint ("Task1 is running, attempt to take mutex!\n");

    if (xQueueTakeMutexRecursive(xMutex, 0)){
        for ( ;; ){
            sPrint ("Task1 holding xMutex!\n");
            if (tag) { vTaskResume (xTaskD); tag = !tag; }
        }
    } else {
        sPrint ("Task1 failed to take mutex!\n");
    }
}

void Deleter(void * xPara){
    BOOL tag = TRUE;
    vTaskSuspend (NULL);

    sPrint ("Task2 is running!\n");
    for ( ;; ){
        if (tag) {
            sPrint ("Task2 try to delete mutex without hold it!\n");
            vQueueDelete(xMutex);
            sPrint ("xMutex is deleted by Task2\n");
            tag = !tag;
        } else {
            sPrint ("Task2 is running!!\n");
        }
    }

}