/*
* Attempt to delete a queue which is waiting by a task
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

#include "tools.h"

xQueueHandle xQueue;

static void Sender(void *);
static void Deleter(void *);

void delQueue(void){
    xQueue = xQueueCreate(1, 0);

    xTaskCreate(Sender, (signed char *) "Task1", 1000, NULL, 2, NULL);
    xTaskCreate(Deleter, (signed char *) "Task2", 1000, NULL, 1, NULL);

    vTaskStartScheduler();
}

void Sender(void * xPara){
    sPrint ("Sender is running\n");

    for ( ;; ){
        sPrint ("Sender: I'm sending items to xQueue\n");

        if (xQueueSend(xQueue, NULL, 20)){
            sPrint ("Sender: I've send an item to xQueue\n");
        } else {
            sPrint ("Sender: Fail to send the item to xQueue\n");
        }
    }
}

void Deleter(void * xPara){
    BOOL tag = TRUE;
    sPrint ("Deleter is running\n");

    for ( ;; ){
        if (tag) {
            vQueueDelete(xQueue);
            tag = !tag;
            sPrint ("Deleter: xQueue is deleted\n");
        }
    }
}