/*
* Try to give a mutex with QueueSend.
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

#include "tools.h"

xQueueHandle xMutex;
xTaskHandle xSender;

static void MutexHolder(void *);
static void Sender(void *);

void givMutexS(){
    xMutex = xQueueCreateMutex(queueQUEUE_TYPE_MUTEX);

    xTaskCreate(MutexHolder, (signed char *) "Task1", 1000, NULL, 2, NULL);
    xTaskCreate(Sender, (signed char *) "Task2", 1000, NULL, 1, & xSender);

    vTaskStartScheduler();

}

void MutexHolder(void * xPara) {
    sPrint ("Mutex holder is running and taking xMutex!\n");

    for ( ;; ){
        if (xQueueTakeMutexRecursive(xMutex, 0)){
            sPrint ("Mutex holder holding xMutex!\n");
            vTaskSuspend(NULL);
        }else {
            sPrint ("Mutex holder is fail to take xMutex!\n");
        }
    }
}

void Sender(void * xPara) {
    sPrint ("Sender is running\n");

    for ( ;; ){
        sPrint ("Sender try to take xMutex, which should be failed!\n");
        if (xQueueTakeMutexRecursive(xMutex, 0)){
            sPrint ("Sender holding xMutex!\n");
        }else {
            sPrint ("Sender failed to take xMutex!\n");
        }
        sPrint ("Sender attempt to give mutex by QueueSend!\n");
        xQueueSend(xMutex, NULL, 0, queueSEND_TO_BACK);
        vTaskDelay(100);
    }
}