#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "semphr.h"
#include "task.h"
#include "queue.h"

xSemaphoreHandle xMutex;
xTaskHandle tskH;
static void MutexHolder(void *);
static void Preemptor(void *);
static void Normal(void *);

void mutexReady(void){
	xMutex = xSemaphoreCreateMutex();

	xTaskCreate(MutexHolder, (signed char *) "Task1", 1000, NULL, 2, & tskH);
	xTaskCreate(Preemptor, (signed char *) "Task2", 1000, NULL, 3, NULL);
	xTaskCreate(Normal, (signed char*) "Task3", 1000, NULL, 4, NULL);

	vTaskStartScheduler();
}

void MutexHolder(void * xPara){
	long i;
	
	printf ("Task1 is running, attempt to take mutex!\n");
	xSemaphoreTake(xMutex, portMAX_DELAY);
	for ( ;; ){
		printf ("Task1 is running, holding xMutex!\n");
		for(i = 0; i < 100000000; i ++);
	}
}

void Preemptor(void * xPara){
	vTaskDelay(10);
	
	printf ("Task2 is running, attempt to take mutex!\n");
	xSemaphoreTake(xMutex, portMAX_DELAY);

	for ( ;; )
		printf ("Task2 is running\n");
}

void Normal(void * xPara){
	long i;

	vTaskDelay(20);
	vTaskPrioritySet(tskH, 6);

	for ( ;; ){
		printf ("Task3 is running\n");
		for (i = 0; i < 100000000; i++);
	}
}