/*
* Try to take a mutex with QueueReceive.
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

#include "tools.h"

xQueueHandle xMutex;
xTaskHandle xMutexHolder;

static void Receiver(void *);
static void MutexHolder(void *);

void takMutexR(void){
    xMutex = xQueueCreateMutex(queueQUEUE_TYPE_MUTEX);

    xTaskCreate(MutexHolder, (signed char *) "Task1", 1000, NULL, 2, & xMutexHolder);
    xTaskCreate(Receiver, (signed char *) "Task2", 1000, NULL, 1, NULL);

    vTaskStartScheduler();

}

void Receiver(void * xPara){
    long i;
    sPrint ("Receiver is running!\n");

    for ( ;; ){
        sPrint ("Receiver receiving from xMutex!\n");
        for(i = 0; i <= 10000; i ++);
        xQueueGenericReceive(xMutex, NULL, 0, pdFALSE);
        vTaskResume(xMutexHolder);
    }
}

void MutexHolder(void * xPara){
    vTaskSuspend(NULL);

    sPrint ("Mutex holder is running!\n");
    sPrint ("Mutex holder should be able to take xMutex\n");

    for ( ;; ){
        if (xQueueTakeMutexRecursive(xMutex, 0)){
            sPrint ("Mutex holder holding xMutex!\n");
        }else {
            sPrint ("Mutex holder failed to take xMutex!\n");
        }
    }
}

