/*
* According to API Manual, if vTaskSuspendAll() be called, xTaskResumeAll()
* should be called same time to resume the scheduler. However, method
* vTaskSuspendAll() did not check overflow of the counter. In this case, it
* shows only call xTaskResumeAll() once can resume the scheduler from millions
* calls of vTaskSuspendAll().
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

#include "tools.h"

static void unSchedulTask(void *);
static void RunningTask(void *);
xTaskHandle unSchTask;

void infSuspAll(void){
	xTaskCreate(unSchedulTask, (signed char *)"unSchTask", 1000, NULL, 0, & unSchTask);
	xTaskCreate(RunningTask, (signed char *)"runningTask", 1000, NULL, 1, NULL);

	vTaskStartScheduler();
}

static void unSchedulTask(void * xPara){
	int c = 0;

	while(TRUE){
		if (c++ % 1000000 == 0)
		sPrint("I shouldn't excute\n");
	}
}

static void RunningTask(void * xPara){
	BOOL tag = TRUE;
	unsigned portBASE_TYPE c = 0;

	while(TRUE){
		vTaskSuspendAll();

		if (c++ % 100000000 == 0)
			sPrint("I should be permentally excuting, %lu\n", c);

		if (!tag && c == 1) xTaskResumeAll();

		if (tag) { vTaskPrioritySet(unSchTask, configMAX_PRIORITIES); tag = !tag; }
	}

}