/*
* This scenario shows that the priority modification has no efficient to the order of
* waiting tasks.
*
* Initial:
*		Task1(2) would direct send items to the xQueue;
*		Task2(3) would be blocked for 1 tick, then send items to the xQueue;
*		Task3(4) would be blocked for 2 ticks, then send items to the xQueue;
*		Task4(1) would be blocked for 3 ticks, then send items to the xQueue;
*		Task5(0) recieve an item from xQueue every 20 ticks. Decrease the
*			priority of Task2 to 1 and increase the priority of Task4 from 1
*			to 4.
*
* Befor Task5 Recieve items from xQueue, Task1-4 would be blocked in order
* Task3(4) -> Task2(3) -> Task1(2) -> Task4(1), sorting by priority. When Task5 start
* to recieve items from xQueue, The priority of Task1 and Task3 would be changed to 5
* and 3 respectively. Once Task3(4) released, decreased the priority to 3 and reblocked
* it would be inserted after Task1(2) which have the new priority of 5. Therefore, the
* new order is,
* Task2(3) -> Task1(5) -> Task3(3) -> Task4(1)
* 
*/
#include <stdio.h>

/* Kernel includes. */
#include <FreeRTOS.h>
#include "task.h"
#include "queue.h"

static void TaskS(void *xPara);
static void TaskR(void *xPara);
xTaskHandle tar, tar1;
xQueueHandle xQueue;


void waitingList1(void){
	xQueue = xQueueCreate(10, sizeof(long));

	if (xQueue != NULL){
		xTaskCreate(TaskS, (signed char *) "Task1", 1000, (void *) 0, 2, & tar);
		xTaskCreate(TaskS, (signed char *) "Task2", 1000, (void *) 1, 3, NULL);
		xTaskCreate(TaskS, (signed char *) "Task3", 1000, (void *) 2, 4, & tar1);
		xTaskCreate(TaskS, (signed char *) "Task4", 1000, (void *) 3, 1, NULL);

		xTaskCreate(TaskR, (signed char *) "Task5", 1000, NULL, 0, NULL);
	}
	vTaskStartScheduler();

}

static void TaskS(void * xPara){
	long d, v, oldTick;
	d = (int) xPara;
	v = (long) uxTaskPriorityGet(NULL);
	
	oldTick = 0;

	for( ;; ){
//		if (xTaskGetTickCount() != oldTick){
			if (oldTick < 4)
				vTaskDelay(d);
			oldTick = xTaskGetTickCount();
			printf("%d***(%d)**||", oldTick, d);
				
			xQueueSend(xQueue, & v, 1000);
			printf("*****%d \n", d);

//		}
	}
}

static void TaskR(void * xPara){
	long v;
	
	
	for( ;; ){
		
		vTaskDelay(20);
		vTaskPrioritySet(tar, 5);
		vTaskPrioritySet(tar1, 3);

		if (xQueuePeek(xQueue, &v, portMAX_DELAY) == pdPASS){
			printf("---%d---\n", v);
			xQueueReceive(xQueue, &v, portMAX_DELAY);
		}
		else
			printf("invalid\n");
	}
}